/*
** Author: dimis
** email : diochnos AT gmail DOT com
**
** File Name: gettimeofday.h
**
** skills (version 1.0)
** Date Started :  7 September 2009.
** Date Finished: 14 September 2009.
**
**
** Tab space: 3
**
**
** The header for the "gettimeofday" file.
**
*/

#ifndef __GET_TIME_OF_DAY_H__
#define __GET_TIME_OF_DAY_H__

/* Comment the following line when NOT working under Windows. */
//#define WORKING_UNDER_WINDOWS 1


#if defined WORKING_UNDER_WINDOWS

/* To eliminate warning about timezone. */
#ifndef _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS 1
#endif

/*
** Define gettimeofday() for usage under WINDOWS.
**
** Source code from: http://www.openasthra.com/c-tidbits/gettimeofday-function-for-windows/
*/

#include <ctime>
// This should do the trick in theory.
// For some strange reason it does not work. :-(
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#if defined(_MSC_VER) || defined(_MSC_EXTENSIONS)
#define DELTA_EPOCH_IN_MICROSECS  11644473600000000Ui64
#else
#define DELTA_EPOCH_IN_MICROSECS  11644473600000000ULL
#endif

struct timeval {
  long tv_sec;
  long tv_usec;
};

struct timezone {
  int  tz_minuteswest; /* minutes W of Greenwich */
  int  tz_dsttime;     /* type of dst correction */
};

/* The implementation of the function under Windows. */
int gettimeofday(struct timeval *, struct timezone *);


#else
/*
** Not working under Windows. So fetch gettimeofday() by <sys/time.h> library.
*/

#include <sys/time.h>

#endif

/*
**
** Also include my version for computing time difference between events.
** This should be done on ANY PLATFORM.
*/

/* A simple structure to compute time difference. */
typedef struct {
	int		secs;
	int		usecs;
} TIME_DIFF;

TIME_DIFF * my_difftime (struct timeval *, struct timeval *);


#endif
