/*
** Author: dimis
** email : diochnos AT gmail DOT com
**
** File Name: math_toolbox.h
**
** skills (version 1.0)
** Date Started :  7 September 2009.
** Date Finished: 14 September 2009.
**
** skills (version 2.0)
** Date Started : 15 September 2009.
** Date Finished: 16 September 2009.
**
**
** Tab space: 3
**
**
** The header file for the mathematical toolbox.
**
*/

#ifndef __MATH_TOOLBOX_H__
#define __MATH_TOOLBOX_H__

#include <ctime>
#include "mighty_classes.h"
#include "gettimeofday.h"

/*****************************************************************************/

enum Printing_Methods { DEPRECATED = 0, GODEPRECATED, NEAT, GONEAT, FANCY, GOFANCY };
#define MAX_PRINTING_METHOD GOFANCY

#define DIFF_SKILL_TREES 255

/*****************************************************************************/

class MathToolbox {
	public:
								MathToolbox ();
								~MathToolbox ();
		unsigned char		getPrintingMethod () const;
		bool					setPrintingMethod (const unsigned char);
		void					printStatistics (HERO_PTR, const clock_t, const clock_t);
		void					printStatistics (HERO_PTR, TIME_DIFF *);
		bool 					incrementOccurrences (const unsigned char);
		long unsigned int getOccurrences (const unsigned char) const;
		void 					initializeOccurrences ();
		//bool 					setOccurrences (const unsigned char, const long unsigned int);
		void 					setProbabilities ();


	private:
		void				printStatisticsDeprecated (HERO_PTR, const clock_t, const clock_t);
		void				printStatisticsNeat (HERO_PTR, const clock_t, const clock_t);
		void				printStatisticsFancy (HERO_PTR, const clock_t, const clock_t);
		void				printStatisticsDeprecated (HERO_PTR, TIME_DIFF *);
		void				printStatisticsNeat (HERO_PTR, TIME_DIFF *);
		void				printStatisticsFancy (HERO_PTR, TIME_DIFF *);
		void				printStatisticsGODeprecated (HERO_PTR, TIME_DIFF *);
		void				printStatisticsGONeat (HERO_PTR, TIME_DIFF *);
		void				printStatisticsGOFancy (HERO_PTR, TIME_DIFF *);
		// Private variables.
		unsigned char			printing_method;
		long unsigned int 	occurrences [DIFF_SEC_SKILLS];
		double 					probabilities [DIFF_SEC_SKILLS];
};

typedef MathToolbox MT;
typedef MT * MT_PTR;

/*****************************************************************************/

#endif
