/*
** Author: dimis
** email : diochnos AT gmail DOT com
**
** File Name: mighty_classes.h
**
** skills (version 1.0)
** Date Started :  7 September 2009.
** Date Finished: 14 September 2009.
**
** skills (version 2.0)
** Date Started : 15 September 2009.
** Date Finished: 16 September 2009.
**
**
** Tab space: 3
**
**
** The header file for the "core" of the implementation.
**
*/

#ifndef __MIGHTY_CLASSES_H__
#define __MIGHTY_CLASSES_H__

#include <ctime>
#include <cstring>
#include "sec_skills_mighty.h"
//#include "math_toolbox.h"

/*****************************************************************************/

struct skill_offer{
	unsigned char left;
	unsigned char right;
};

typedef struct skill_offer SKILL_OFFER;
typedef SKILL_OFFER * SKILL_OFFER_PTR;

/*****************************************************************************/

class Hero {
	public:
								Hero (const unsigned char, const unsigned char name);
								~Hero ();
		void 					myInit (const unsigned char, const unsigned char name);
		unsigned char     get_magic_schools () const;
		unsigned char 		get_max_number_of_magic_schools () const;
		bool              get_has_wisdom () const;
		bool 					get_fully_upgraded () const;
		unsigned char     get_hero_level () const;
		unsigned char 		get_last_magic_level_offer () const;
		unsigned char 		get_last_wisdom_level_offer () const;
		unsigned char 		get_hero_class () const;
		unsigned char 		get_hero_name () const;
		const char *		get_Name_string () const;
		unsigned char 		get_skill_from_slot (const unsigned char) const;
		unsigned char		get_skill_expertize_on_slot (const unsigned char) const;
		unsigned char 		get_skill_slot (const unsigned char) const;
		unsigned char		get_initial_skills () const;
		unsigned char *	get_skill_chances () const;
		SKILL_OFFER_PTR 	get_skill_offer (const unsigned char);
		void 					increment_level ();
		double *          ANSA_policy ();
		void              print_Name () const;
		void 					addSkill (const unsigned char);
		bool 					is_magic_school (const unsigned char) const;
		void					initialize_seed (const unsigned char);
		void					set_seed (const unsigned int);
		unsigned int		get_seed () const;
		unsigned int		set_sec ();
		unsigned int		Get_Random_Number ();


	private:
		void 					depth_first_search (const unsigned char, bool *, unsigned char *, const unsigned char, bool, const double, const unsigned char, double *);
		unsigned char 		Roll_Dice_for_new_skill (const unsigned char);
		unsigned char 		Roll_Dice_for_new_magic_skill (const unsigned char);
		unsigned char 		Roll_Dice_for_magic_skill_upgrade (unsigned char [], const unsigned char);
		unsigned char 		Roll_Dice_for_skill_upgrade (unsigned char [], const unsigned char, const unsigned char);

		unsigned char     classification;
		unsigned char     name;
		unsigned char     level;
		unsigned char     initial_skills;
		unsigned char     skills [SKILL_SLOTS];
		unsigned char     expertize [SKILL_SLOTS];
		unsigned char     magic_schools;
		unsigned char 		max_number_of_magic_schools;
		bool              has_wisdom;
		unsigned char *   skill_chances;
		unsigned char 		last_magic_level_offer;
		unsigned char 		last_wisdom_level_offer;
		bool 					available_skills [DIFF_SEC_SKILLS];
		unsigned char 		mapping_skills [DIFF_SEC_SKILLS];
		unsigned char 		free_slot;
		unsigned int		seed;
		unsigned int		sec;
};

typedef Hero HERO;
typedef HERO * HERO_PTR;

/*****************************************************************************/

const char * 	get_skill_name_12 (const unsigned char pointer);
const char * 	get_skill_name (const unsigned char pointer);
const char * 	get_skill_name_consecutive (const unsigned char pointer);

/*****************************************************************************/

#endif
