/*
** Author: dimis
** email : diochnos AT gmail DOT com
**
** File Name: policies.h
**
** skills (version 1.0)
** Date Started :  7 September 2009.
** Date Finished: 14 September 2009.
**
** skills (version 2.0)
** Date Started : 15 September 2009.
** Date Finished: 16 September 2009.
**
**
** Tab space: 3
**
**
** The header file for different policies.
**
*/

#ifndef __POLICIES_H__
#define __POLICIES_H__

/*****************************************************************************/

class DecisionMaker {
	public:
										DecisionMaker (HERO_PTR);
										~DecisionMaker ();
		virtual unsigned char 	applyPolicy (SKILL_OFFER_PTR) = 0;
		virtual void				LoopInitializer () = 0;

	protected:
		HERO_PTR						myHero;
};

typedef DecisionMaker * DEC_MAK_PTR;

/*****************************************************************************/

class HeroAlwaysRight: public DecisionMaker {
	public:
										HeroAlwaysRight(HERO_PTR);
		virtual unsigned char 	applyPolicy (SKILL_OFFER_PTR offer);
		virtual void				LoopInitializer ();
};

/*****************************************************************************/

class HeroAlwaysLeft: public DecisionMaker {
	public:
										HeroAlwaysLeft(HERO_PTR);
		virtual unsigned char 	applyPolicy (SKILL_OFFER_PTR offer);
		virtual void				LoopInitializer ();
};

/*****************************************************************************/

class HeroAlwaysLeftThenPref: public DecisionMaker {
	public:
										HeroAlwaysLeftThenPref(HERO_PTR, unsigned char *);
		virtual unsigned char 	applyPolicy (SKILL_OFFER_PTR offer);
		virtual void				LoopInitializer ();

	private: 
		int				Preference[DIFF_SEC_SKILLS];
};

/*****************************************************************************/

class HeroSeekPrefOtherwiseUpgrade: public DecisionMaker {
	public:
										HeroSeekPrefOtherwiseUpgrade(HERO_PTR, unsigned char *);
		unsigned char				get_number_of_unwanted_skills () const;
		void							printPreferences ();
		virtual unsigned char 	applyPolicy (SKILL_OFFER_PTR offer);
		virtual void				LoopInitializer ();

	private:
		bool							qualifies_on_top (const unsigned char) const;
		int							Preference[DIFF_SEC_SKILLS];
		unsigned char				unwanted;
};

/*****************************************************************************/

class HeroFollowsFrank: public DecisionMaker {
	public:
										HeroFollowsFrank(HERO_PTR, unsigned char *);
		unsigned char				get_number_of_unwanted_skills () const;
		void							printPreferences ();
		virtual unsigned char 	applyPolicy (SKILL_OFFER_PTR offer);
		virtual void				LoopInitializer ();

	private:
		bool							qualifies_on_top (const unsigned char) const;
		int							Preference[DIFF_SEC_SKILLS];
		unsigned char				unwanted;
		unsigned char				initial_available_upgrades;
		unsigned char				available_upgrades;	// This is recorded here so as to avoid overhead in other policies (see 'addSkill').
};


/*****************************************************************************/

#endif
