/*
** Author: dimis
** email : diochnos AT gmail DOT com
**
** File Name: skills.cpp
**
** skills (version 1.0)
** Date Started :  7 September 2009.
** Date Finished: 14 September 2009.
**
** skills (version 2.0)
** Date Started : 15 September 2009.
** Date Finished: 16 September 2009.
**
**
** Tab space: 3
**
**
** The "main" file.
**
*/

// So that you avoid warning for strcpy () in Visual Studio:
#ifndef _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_DEPRECATE 1
#endif

#include <fstream>
#include <iostream>
#include <iomanip>
#include <cstring>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include "sec_skills_mighty.h"
#include "mighty_classes.h"
#include "policies.h"
#include "math_toolbox.h"
#include "gettimeofday.h"	/* necessary for gettimeofday() */

#define CURRENT_VERSION_NUM 2.0
#define CURRENT_VERSION_STR "2.0"
#define CURRENT_VERSION_RELEASE_DATE "September 14, 2009"

/*
** External global variables.
*/
extern const char * Alchemists_Names [];
extern const char * Barbarians_Names [];
extern const char * Beastmasters_Names [];
extern const char * Death_Knights_Names [];
extern const char * Demoniacs_Names [];
extern const char * Knights_Names [];
extern const char * Overlords_Names [];
extern const char * Planeswalkers_Names [];
extern const char * Rangers_Names [];
extern unsigned char Skills_Alphabetic_to_Game_Index [];
extern unsigned char Skills_Game_Index_to_Alphabetic [];

/*****************************************************************************/

unsigned char * Read_Selections (const char *);
bool 	are_valid (HERO_PTR, unsigned char *, const char *);
void default_version_message ();
void default_about_message ();
void default_error_message ();
void default_help_message ();
void default_log_message ();
void PrintSelections (unsigned char *);
const char * get_policy_string (const int);
void write_log_file_header (std::ofstream &, HERO_PTR, const int, unsigned char *);
void write_tree_header_on_log (std::ofstream &, const unsigned char);
void write_skill_offer_on_log (std::ofstream &, const unsigned char, const unsigned char, const unsigned char, const unsigned char, const unsigned char);
void write_overall_skills_on_tree_in_log (std::ofstream &, HERO_PTR);
void write_log_file_footer (std::ofstream &);

/*****************************************************************************/

int 	main (int argc, char * argv [])
{
	unsigned char		pointer;
	int					algorithm;
	unsigned char		tree, choice, slot;
	unsigned char *	selections = NULL;
	DecisionMaker *	dMaker;
	SKILL_OFFER_PTR 	offer;
	struct timeval		start, end;
	TIME_DIFF *			difference;

	if (argc == 2) {
		char * request = new char [strlen(argv[1]) + 1];

		strcpy(request, argv[1]);
		for (pointer = 0; pointer < strlen (argv [1]); pointer++)
			request [pointer] = toupper ( request [pointer] );

		if (strcmp(request, "-VERSION") == 0)
			default_version_message ();
		else if (strcmp(request, "-HELP") == 0)
			default_help_message ();
		else if (strcmp(request, "-ABOUT") == 0)
			default_about_message ();
		else if (strcmp(request, "-LOG") == 0)
			default_log_message ();
		else {
			default_error_message ();

			exit(1);
		}

		delete [] request;

		exit(0);
	}
	if ((argc != 4) && (argc != 5)) {
		default_error_message ();

		exit (1);
	}


	/*
	** Program has 4 or 5 arguments. Prepare for execution.
	*/


	char * 	given_class = new char [strlen (argv [1]) + 1];
	char * 	given_name = new char [strlen (argv [2]) + 1];

	// Convert to UPPERCASE.
	strcpy (given_class, argv [1]);
	for (pointer = 0; pointer < strlen (argv [1]); pointer++)
		given_class [pointer] = toupper ( given_class [pointer] );

	// Convert to UPPERCASE.
	strcpy (given_name, argv [2]);
	for (pointer = 0; pointer < strlen (argv [2]); pointer++)
		given_name [pointer] = toupper ( given_name [pointer] );

	/*
	** Validate user input.
	*/
	unsigned char 	classification;
	unsigned char 	name;

	if (strcmp (given_class, "ALCHEMIST") == 0 )
		classification = ALCHEMIST;
	else if (strcmp (given_class, "BARBARIAN") == 0 )
		classification = BARBARIAN;
	else if (strcmp (given_class, "BEASTMASTER") == 0 )
		classification = BEASTMASTER;
	else if (strcmp (given_class, "DEATH_KNIGHT") == 0 )
		classification = DEATH_KNIGHT;
	else if (strcmp (given_class, "DEMONIAC") == 0 )
		classification = DEMONIAC;
	else if (strcmp (given_class, "KNIGHT") == 0 )
		classification = KNIGHT;
	else if (strcmp (given_class, "OVERLORD") == 0 )
		classification = OVERLORD;
	else if (strcmp (given_class, "PLANESWALKER") == 0 )
		classification = PLANESWALKER;
	else if (strcmp (given_class, "RANGER") == 0 )
		classification = RANGER;
	else {
		// Free-up memory for first two arguments.
		delete 	[] given_class;
		delete 	[] given_name;

		std::cerr << "Invalid Hero class given." << std::endl;
		std::cerr << "Please execute program with -help parameter to view help." << std::endl;

		exit (2);
	}

	switch(classification) {
		case ALCHEMIST:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Alchemists_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case BARBARIAN:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Barbarians_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case BEASTMASTER:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Beastmasters_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case DEATH_KNIGHT:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Death_Knights_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case DEMONIAC:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Demoniacs_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case KNIGHT:
			for (pointer = 0; pointer < NUM_HEROES + 1; pointer++) {
				if (strcmp (given_name, Knights_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case OVERLORD:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Overlords_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case PLANESWALKER:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Planeswalkers_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case RANGER:
			for (pointer = 0; pointer < NUM_HEROES + 1; pointer++) {
				if (strcmp (given_name, Rangers_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		default:
name_error:
			std::cerr << "Invalid Hero name given." << std::endl;
			std::cerr << "Please execute program with -help parameter to view help." << std::endl;

			// Free-up memory for first two arguments.
			delete 	[] given_class;
			delete 	[] given_name;

			exit (4);

			break;
	}


	/*
	** Procceed to execution of Always Left policy.
	*/
normal_execution:

	// Free-up memory for first two arguments.
	delete 	[] given_class;
	delete 	[] given_name;

	char * 	given_algorithm = new char [strlen (argv [3]) + 1];

	strcpy (given_algorithm, argv [3]);
	for (pointer = 0; pointer < strlen (argv [3]); pointer++)
		given_algorithm [pointer] = toupper ( given_algorithm [pointer] );

	if (strcmp (given_algorithm, "AR") == 0 )
		algorithm = AR_ALGO;
	else if (strcmp (given_algorithm, "ANSA") == 0 )
		algorithm = ANSA_ALGO;
	else if (strcmp (given_algorithm, "AL") == 0 )
		algorithm = AL_ALGO;
	else if (strcmp (given_algorithm, "ALTP") == 0 )
		algorithm = ALTP_ALGO;
	else if (strcmp (given_algorithm, "SPOU") == 0 )
		algorithm = SPOU_ALGO;
	else if (strcmp (given_algorithm, "FRANK") == 0 )
		algorithm = FRANK_ALGO;
	//else if (strcmp (given_algorithm, "FMTP") == 0 )
	//	algorithm = FMTP_ALGO;
	else {
		delete 	[] given_algorithm;

		std::cerr << "Invalid algorithm given." << std::endl;
		std::cerr << "Please execute program with -help parameter to view help." << std::endl;

		exit (5);
	}

	// Free-up memory.
	delete 	[] given_algorithm;



	// Create an instance of the selected hero for each thread.
	HERO_PTR	yet_another_hero = new HERO (classification, name);


	// Initialize DecisionMaker based on algorithm selection.
	switch(algorithm) {
		//case AR_ALGO:
		case ANSA_ALGO:
			dMaker = new HeroAlwaysRight (yet_another_hero);
			break;

		case AL_ALGO:
			dMaker = new HeroAlwaysLeft (yet_another_hero);
			break;

		case ALTP_ALGO:
			selections = Read_Selections ( DEFAULT_ALTP_PREFS_FILE );
			// Same initialization for all instances ==> It suffices to check one of them (--> index: 0).
			if (are_valid (yet_another_hero, selections, DEFAULT_ALTP_PREFS_FILE))
				dMaker = new HeroAlwaysLeftThenPref (yet_another_hero, selections);
			else {
				// Problem with the entries in the file.
				// Deallocate memory and return.
				delete yet_another_hero;
				delete 	[] selections;
				exit(6);
			}
			break;

		case SPOU_ALGO:
			selections = Read_Selections ( DEFAULT_SPOU_PREFS_FILE );
			//std::cout << "about to print selections" << std::endl;
			//PrintSelections (selections);
			//std::cout << "selections printed" << std::endl;
			//
			// Similar Case as above:
			// Same initialization for all instances ==> It suffices to check one of them.
			if (are_valid (yet_another_hero, selections, DEFAULT_SPOU_PREFS_FILE)) {
				dMaker = new HeroSeekPrefOtherwiseUpgrade (yet_another_hero, selections);
				//dynamic_cast<HeroSeekPrefOtherwiseUpgrade *>(dMaker)->printPreferences ();
			}
			else {
				// Problem with the entries in the file.
				// Deallocate memory and return.
				delete yet_another_hero;
				delete 	[] selections;
				exit(6);
			}
			break;
			
		case FRANK_ALGO:
			selections = Read_Selections ( DEFAULT_FRANK_PREFS_FILE );
			if (are_valid (yet_another_hero, selections, DEFAULT_FRANK_PREFS_FILE))
				dMaker = new HeroFollowsFrank (yet_another_hero, selections);
			else {
				// Problem with the entries in the file.
				// Deallocate memory and return.
				delete yet_another_hero;
				delete 	[] selections;
				exit(6);
			}
			break;

//		case FMTP_ALGO:
//			std::cerr << "The selected algorithm is not supported yet!" << std::endl;
//			exit(7);
			//dMaker = new HeroAlwaysLeft (yet_another_hero);
//			break;

		default:
			std::cerr << "You should not enter here while selecting policy!" << std::endl;
			exit(7);
			break;
	}



	/*
	** Fetch printing procedure.
	** By default use FANCY output.
	*/
	unsigned char	output_algo = FANCY;
	if (argc == 5) {
		char * requested_output = new char [strlen(argv[4]) + 1];
		strcpy (requested_output, argv[4]);
		for (pointer = 0; pointer < strlen(argv[4]) + 1; pointer++)
			requested_output[pointer] = toupper( requested_output[pointer] );		// Convert to uppercase.

		if (strcmp(requested_output, "DEPRECATED") == 0)
			output_algo = DEPRECATED;
		else if (strcmp(requested_output, "GODEPRECATED") == 0)
			output_algo = GODEPRECATED;
		else if (strcmp(requested_output, "NEAT") == 0)
			output_algo = NEAT;
		else if (strcmp(requested_output, "GONEAT") == 0)
			output_algo = GONEAT;
		else if (strcmp(requested_output, "GOFANCY") == 0)
			output_algo = GOFANCY;
		else if (strcmp(requested_output, "FANCY") != 0)
			std::cerr << "Warning: Invalid output requested. FANCY used instead." << std::endl;

		delete	[] requested_output;
	}


	// Store user preferences for number of episodes and printing method.
	// Also store seed just in case it is needed for debugging within the
	// Math Toolbox.
	MT_PTR myMathToolbox;
	myMathToolbox = new MT;

	myMathToolbox->setPrintingMethod ( output_algo );


	/*
	** All initializations took place!
	** Now create threads perform MULTI-THREADED computations! :-)
	*/
	// Count time!
	gettimeofday (&start, NULL);
	//start = clock ();

	myMathToolbox->initializeOccurrences (); 	// Not necessary on single hero.


	/* 
	** Initialize log files.
	*/
	std::ofstream skillslogFD;
	skillslogFD.open (DEFAULT_OVERALL_SKILLS_LOG_FILE);
	write_log_file_header (skillslogFD, yet_another_hero, algorithm, selections);
	
	std::ofstream detailedlogFD;
	detailedlogFD.open (DEFAULT_DETAILED_SKILLS_LOG_FILE);
	write_log_file_header (detailedlogFD, yet_another_hero, algorithm, selections);

	if ((algorithm != AR_ALGO) && (algorithm != AL_ALGO))
		delete selections;	// Free up memory now that it has been recorded in the log too.


	/*
	** Now compute!
	*/
	for (tree = 0; tree < 255; tree++) {
		// Traverse the tree according to the policy

		// Initialize log file for this skill tree
		write_tree_header_on_log (skillslogFD, tree);
		write_tree_header_on_log (detailedlogFD, tree);

		// Now explore the tree according to the policy
		yet_another_hero->myInit (yet_another_hero->get_hero_class (), yet_another_hero->get_hero_name ());
		dMaker->LoopInitializer ();

		while ( !yet_another_hero->get_fully_upgraded () ) {
			// Hero can upgrade an existing skill or acquire a new one.
			yet_another_hero->increment_level ();

			offer = yet_another_hero->get_skill_offer (tree+1);
			choice = dMaker->applyPolicy (offer);
			yet_another_hero->addSkill ( choice );

			// Write options and selection to the detailed log file
			write_skill_offer_on_log (detailedlogFD, tree, yet_another_hero->get_hero_level (), offer->left, offer->right, choice);

			delete offer;

			//if (( myHero->get_hero_level () == 6 ) && (i==4) )
			//	std::cin >> temp;
		}

		for (slot = 0; slot < SKILL_SLOTS; slot++)
			myMathToolbox->incrementOccurrences( yet_another_hero->get_skill_from_slot (slot) );

		// Write skills on overall log file for skills.
		write_overall_skills_on_tree_in_log (skillslogFD, yet_another_hero);

	}
	write_log_file_footer (skillslogFD);
	write_log_file_footer (detailedlogFD);
	skillslogFD.close();
	detailedlogFD.close();
	gettimeofday (&end, NULL);
	//finish = clock ();
	difference = my_difftime (&start, &end);
	
	myMathToolbox->printStatistics ( yet_another_hero, difference);


	/*
	** Free up memory reserved
	*/
	delete yet_another_hero;
	delete dMaker;
	delete myMathToolbox;
	/* Delete data structure storing time difference. */
	delete difference;

	return 	0;
}

/*****************************************************************************/

unsigned char * Read_Selections (const char * name)
{
	int i, j;
	char current_line [14];
	bool already_found[DIFF_SEC_SKILLS];
	unsigned char * selections = (unsigned char *) NULL;

	/* Check if file 'selections.txt' exists. */
	std::ifstream selFD ( name );

	if ( !selFD ) {
		std::cerr << "Usage: Program expects file " << name << " in same directory.\n";

		exit (6);
	}

	// Initialize "double_appearence" array.
	for (i = 0; i < DIFF_SEC_SKILLS; i++)
		already_found[i] = false;	// No skill is already read.

	/*
	** Store user's selections in memory.
	*/
	selections = new unsigned char [DIFF_SEC_SKILLS];
	
	for (i = 0; i < (DIFF_SEC_SKILLS - 1); i++) {
		selFD.getline (current_line, 13);
		for (j = 0; j < (int) strlen (current_line ); j++) //convert selection to uppercase
				current_line[j] = (char) toupper( (int) current_line[j] );
		for (j = 1; j < DIFF_SEC_SKILLS; j++) {
			if ( strcmp( current_line, get_skill_name_consecutive (j) ) == 0 ) {
				if ( !already_found[j] )
					already_found [j] = true;
				else {
					// We have a problem because same skill was read earlier in file.
					// Indicate error to user.
					std::cerr << name << ": Duplicate skill (" << get_skill_name_consecutive (j);
					std::cerr << ") on input line " << (int) (i + 1) << "." << std::endl;

					exit(6);
				}
				selections[i] = j; 	// Store preference.
				break;
			}
		}
		if ( j == DIFF_SEC_SKILLS ) {
			// Parser was unable to locate skill given by user.
			std::cerr << name << ": Invalid skill given on input line " << (int) (i + 1) << "." << std::endl;

			exit (6);
		}
		//std::cout << get_skill_name_consecutive(k) << "." << std::endl;
	}
	selections[DIFF_SEC_SKILLS - 1] = NULL_SKILL; 	// Null-skill no-one wants it.

	selFD.close ();

	return selections;
}

/*****************************************************************************/

bool 	are_valid (HERO_PTR yet_another_hero, unsigned char * selections, const char * filename)
{
	int i;
	bool found;
	//char temp[32];

	found = false;
	//std::cout << "selections[0] : " << get_skill_name (selections[0]) << std::endl;
	//std::cout << "slot      [0] : " << get_skill_name (yet_another_hero->get_skill_from_slot (0)) << std::endl;
	for (i = 0; i < SKILL_SLOTS; i++) {
		if (selections[i] == yet_another_hero->get_skill_from_slot (0)) {
			found = true;
			break;
		}
	}
	if (!found) {
		std::cerr << "Hero starts with " << get_skill_name( yet_another_hero->get_skill_from_slot (0) );
		std::cerr << " and you did not provide it in the first 8 skills." << std::endl;
		std::cerr << "Please edit your selections in " << filename << " file." << std::endl;

		//std::cin.getline ( temp, 31 );

		return false;;
	}

	if (yet_another_hero->get_skill_from_slot(1) != NULL_SKILL) {
		found = false;
		for (i = 0; i < SKILL_SLOTS; i++) {
			if (selections[i] == yet_another_hero->get_skill_from_slot (1)) {
				found = true;
				break;
			}
		}

		if (!found)	{
			std::cerr << "Hero starts with " << get_skill_name( yet_another_hero->get_skill_from_slot (1) );
			std::cerr << " and you did not provide it in the first 8 skills." << std::endl;
			std::cerr << "Please edit your selections in " << filename << " file." << std::endl;

			//std::cin.getline ( temp, 31 );

			return false;
		}
	}

	return true;
}

/*****************************************************************************/

void default_version_message ()
{
	std::cout << CURRENT_VERSION_STR << std::endl;
}

void default_about_message ()
{
	std::cout << "skills: about" << std::endl;
	std::cout << "~~~~~~~~~~~~~" << std::endl;
	std::cout << "Version: " << CURRENT_VERSION_STR << std::endl;
	std::cout << "Release: " << __DATE__ << ", " << __TIME__ << std::endl << std::endl;
	std::cout << "* For a complete documentation and comments please visit homepage:" << std::endl;
	std::cout << "  http://heroescommunity.com/viewthread.php3?TID=17812&pagenumber=14" << std::endl << std::endl;
	std::cout << "* Bugs and bugfixes can be reported in the forum above (recommended)" << std::endl;
	std::cout << "  or with a direct email at: diochnos AT gmail DOT com." << std::endl << std::endl;
	std::cout << "* Last, but not least, I want to thank all the participants in the thread and" << std::endl;
	std::cout << "  especially: AlexSpl, Ecoris, maretti, Xarfax111, Binabik, and angelito" << std::endl;
	std::cout << "  for their valuable observations. Here, I should also thank Russ, whose" << std::endl;
	std::cout << "  thread motivated me for all this work." << std::endl;
}

void default_error_message ()
{
	std::cout << "\askills" << std::endl;
	std::cout << "~~~~~~" << std::endl;
	std::cout << "Incorrect parameters. Please execute:" << std::endl;
	std::cout << "skills -help" << std::endl;
	std::cout << "for a complete list of available options or visit the homepage at:" << std::endl;
	std::cout << "http://heroescommunity.com/viewthread.php3?TID=17812&pagenumber=14" << std::endl;
}

void default_help_message ()
{
	int pointer;

	std::cout << "skills: help" << std::endl;
	std::cout << "~~~~~~~~~~~~" << std::endl;
	std::cout << "Usage: Program expects 3 or 4 arguments." << std::endl;
	std::cout << "1st  : Hero Class." << std::endl;
	std::cout << "2nd  : Hero Name." << std::endl;
	std::cout << "3rd  : Policy (Skill Selection Algorithm)." << std::endl;
	std::cout << "4th  : Printing method (optional argument)." << std::endl << std::endl;
	std::cout << "Valid names for Hero Classes:" << std::endl;
	std::cout << "Alchemist, Barbarian, Beastmaster, Death_Knight, " << std::endl;
	std::cout << "Demoniac, Knight, Overlord, Planeswalker, Ranger." << std::endl << std::endl;
	std::cout << "Valid names for Heroes:" << std::endl;
	for (pointer = 0; pointer < NUM_HEROES; pointer++) {
		std::cout << Alchemists_Names [pointer] << " ";
		if (pointer == 3)
			std::cout << std::endl;
	}
	std::cout << std::endl << std::endl;
	for (pointer = 0; pointer < NUM_HEROES; pointer++) {
		std::cout << Barbarians_Names [pointer] << " ";
		if (pointer == 3)
			std::cout << std::endl;
	}
	std::cout << std::endl << std::endl;
	for (pointer = 0; pointer < NUM_HEROES; pointer++) {
		std::cout << Beastmasters_Names [pointer] << " ";
		if (pointer == 3)
			std::cout << std::endl;
	}
	std::cout << std::endl << std::endl;
	for (pointer = 0; pointer < NUM_HEROES; pointer++) {
		std::cout << Death_Knights_Names [pointer] << " ";
		if (pointer == 3)
			std::cout << std::endl;
	}
	std::cout << std::endl << std::endl;
	for (pointer = 0; pointer < NUM_HEROES; pointer++) {
		std::cout << Demoniacs_Names [pointer] << " ";
		if (pointer == 3)
			std::cout << std::endl;
	}
	std::cout << std::endl << std::endl;
	for (pointer = 0; pointer < NUM_HEROES + 1; pointer++) { 	// There is also Sir Mullich.
		std::cout << Knights_Names [pointer] << " ";
		if (pointer == 4)
			std::cout << std::endl;
	}
	std::cout << std::endl << std::endl;
	for (pointer = 0; pointer < NUM_HEROES; pointer++) {
		std::cout << Overlords_Names [pointer] << " ";
		if (pointer == 3)
			std::cout << std::endl;
	}
	std::cout << std::endl << std::endl;
	for (pointer = 0; pointer < NUM_HEROES; pointer++) {
		std::cout << Planeswalkers_Names [pointer] << " ";
		if (pointer == 3)
			std::cout << std::endl;
	}
	std::cout << std::endl << std::endl;
	for (pointer = 0; pointer < NUM_HEROES + 1; pointer++) { 	// There is also Gelu.
		std::cout << Rangers_Names [pointer] << " ";
		if (pointer == 4)
			std::cout << std::endl;
	}
	std::cout << std::endl << std::endl << std::endl;
	std::cout << "Valid names for algorithms (policies):" << std::endl;
	std::cout << "AR   : Always Right." << std::endl;
	std::cout << "ANSA : Always Right (same as above)." << std::endl;
	std::cout << "AL   : Always Left." << std::endl;
	std::cout << "ALTP : Always Left-Then Preference." << std::endl;
	std::cout << "SPOU : Seek Preference-Otherwise Upgrade (according to Preference)." << std::endl;
	std::cout << "FRANK: Frank's Skill Selection Method (refer to his thread)." << std::endl;
	//std::cout << "FMTP: First Magic-Then Preference" << std::endl;
	std::cout << std::endl << std::endl;

	std::cout << "Valid names for Printing Methods:" << std::endl;
	std::cout << "DEPRECATED  : The initial (raw) output; useful with 'ansa2excel' program." << std::endl;
	std::cout << "NEAT        : A neat version for the deprecated output." << std::endl;
	std::cout << "FANCY       : Generates FANCY output. This is used by DEFAULT." << std::endl;
	std::cout << "GODEPRECATED: Same as deprecated; secondary skills are shown in \"game-order\"." << std::endl;
	std::cout << "GONEAT      : Same as neat; secondary skills are shown in \"game-order\"." << std::endl;
	std::cout << "GOFANCY     : Same as fancy; secondary skills are shown in \"game-order\"." << std::endl;
	std::cout << std::endl << std::endl;

	std::cout << "Log Files:" << std::endl;
	std::cout << "Upon every execution two log-files are generated so that the user can have" << std::endl;
	std::cout << "the entire picture of the computations that took place. These files are:" << std::endl;
	std::cout << " * " << DEFAULT_OVERALL_SKILLS_LOG_FILE << std::endl;
	std::cout << " * " << DEFAULT_DETAILED_SKILLS_LOG_FILE << std::endl;
}

void	default_log_message ()
{
	std::cout << "skills: log" << std::endl;
	std::cout << "~~~~~~~~~~~" << std::endl << std::endl;
	std::cout << "Version 1.0:" << std::endl;
	std::cout << " * The initial version of the program." << std::endl;
	std::cout << " - Developed: September 7 - 14, 2009." << std::endl;
	std::cout << " - Released : " << __DATE__ << ", " << __TIME__  << "." << std::endl;
	std::cout << std::endl;
	std::cout << "Version 2.0:" << std::endl;
	std::cout << " * Major fix on the function that returns skill offers." << std::endl;
	std::cout << "   Refer to thread for more information." << std::endl;
	std::cout << " * Fixed bugs that determine \"random\" numbers." << std::endl;
	std::cout << " * Two log files are generated on every execution:" << std::endl;
	std::cout << "   " << DEFAULT_OVERALL_SKILLS_LOG_FILE << " and " << DEFAULT_DETAILED_SKILLS_LOG_FILE << std::endl;
	std::cout << " - Developed: September 7 - 14, 2009." << std::endl;
	std::cout << " - Released : " << __DATE__ << ", " << __TIME__  << "." << std::endl;
}

void 	PrintSelections(unsigned char * selections)
{
	int i;

	std::cout << "SELECTIONS" << std::endl;
	for (i = 0; i < DIFF_SEC_SKILLS; i++) {
		std::cout << get_skill_name_12 ( i ) << ": " << (int) selections[i] << std::endl;
	}
	std::cout << "----------" << std::endl;
}

const char * get_policy_string (const int policy)
{
	switch(policy) {
		//case AR_ALGO:
		case ANSA_ALGO:
			return "Always Right";
			break;

		case AL_ALGO:
			return "Always Left";
			break;

		case ALTP_ALGO:
			return "Always Left then Preference";
			break;

		case SPOU_ALGO:
			return "Seek Preference Otherwise Upgrade";
			break;
			
		case FRANK_ALGO:
			return "Frank's";
			break;

		default:
			return "ERROR: INVALID POLICY - get_policy_string" ;
			break;
	}
}

void write_log_file_header (std::ofstream & fd, HERO_PTR yet_another_hero, const int algorithm, unsigned char * selections)
{
	unsigned char		pointer;
	int					temp;

	fd << "Hero  : " << yet_another_hero->get_Name_string ();
	if (strlen(yet_another_hero->get_Name_string ()) < strlen(get_policy_string (algorithm))) {
		for (pointer = 0; pointer < (strlen(get_policy_string (algorithm)) - strlen(yet_another_hero->get_Name_string ())); pointer++)
			fd << " ";
	}
	fd << " |" << std::endl;
	fd << "Policy: " << get_policy_string (algorithm);
	if (strlen(yet_another_hero->get_Name_string ()) > strlen(get_policy_string (algorithm))) {
		for (pointer = 0; pointer < (strlen(yet_another_hero->get_Name_string ()) - strlen(get_policy_string (algorithm))); pointer++)
			fd << " ";
	}
	fd << " |" << std::endl;
	temp = static_cast<int> (strlen(get_policy_string(algorithm)));
	if (static_cast<int> (strlen(yet_another_hero->get_Name_string ())) > temp)
		temp = static_cast<int> (strlen(yet_another_hero->get_Name_string ()));
	temp += 8;
	for (pointer = 0; pointer < (unsigned char) temp; pointer++)
		fd << "_";
	fd << "_|" << std::endl;
	if ((algorithm != AR_ALGO) && (algorithm != AL_ALGO)) {
		// Print user's preferences on skills
		fd << "                 |" << std::endl;
		fd << "Skill priorities |" << std::endl;
		fd << "---------------- |" << std::endl;
		fd << "                 |" << std::endl;
		for (pointer = 0; pointer < DIFF_SEC_SKILLS-1; pointer++) {
			fd << std::setw(2) << (int) (pointer+1) << ": " << get_skill_name_12 (selections [pointer]) << " |" << std::endl;
		}
		for (pointer = 0; pointer < 16; pointer++)
			fd << "_";
		fd << "_|" << std::endl;
	}
}

void write_tree_header_on_log (std::ofstream & fd, const unsigned char tree)
{
	unsigned char pointer;
	int temp;

	fd << std::endl << "Skill Tree #" << static_cast<int> (tree+1) << std::endl;
	if (tree < 9)
		temp = 1;
	else if (tree < 99)
		temp = 2;
	else
		temp = 3;
	temp += 12;
	for (pointer = 0; pointer < temp; pointer++)
		fd << "=";
	fd << std::endl;
}

void write_skill_offer_on_log (std::ofstream & fd, const unsigned char tree, const unsigned char level, const unsigned char left, const unsigned char right, const unsigned char choice)
{
	fd << "Level " << std::setw(2) << static_cast<int> (level) << ":  ";
	fd << " Left: " << get_skill_name_12 (left) << "   ";
	fd << " Right: " << get_skill_name_12 (right) << "   ";
	fd << " Choice: " << get_skill_name (choice) << std::endl;
}

void write_overall_skills_on_tree_in_log (std::ofstream & fd, HERO_PTR yah)
{
	int slot;

	for (slot = 0; slot < DIFF_SEC_SKILLS; slot++) {
		if ((yah->get_skill_slot (slot) < SKILL_SLOTS))
			fd << get_skill_name (slot) << std::endl;
	}
		fd << std::endl;
}

void write_log_file_footer (std::ofstream & fd)
{
	fd << " ____________________________________" << std::endl;
	fd << "|                                    |" << std::endl;
	fd << "| Generated by \"skills\", version " << CURRENT_VERSION_STR << " |" << std::endl;
	fd << "|____________________________________|";
}
