#include <iostream>

void initialize_seed (unsigned int * seed, const unsigned char tree)
{ 
	*seed = 214013 * ((unsigned int) 15) + 156823 * ((unsigned int) tree) + 154079;
}

void set_seed (unsigned int * seed, const unsigned int value) { 
	*seed = value;
}

unsigned int set_sec (unsigned int * sec, const unsigned int seed)
{
	*sec = 214013 * seed + 2531011;
	return *sec;
}

unsigned int Get_Random_Number (unsigned int * sec, const unsigned int seed)
{
	unsigned int	rnd_number, sec2;

	set_sec (sec, seed);
	sec2 = *sec;
	rnd_number = (sec2 >> 16);
	rnd_number &= 32767;			/* Keep only last 15 bits. */

	return rnd_number;
}

/*****************************************************************************/

int main ()
{
	unsigned int seed, sec, Q;

	initialize_seed (&seed, static_cast<unsigned char> (75));
	set_sec (&sec, seed);
	set_seed (&seed, sec);
	Q = Get_Random_Number (&sec, seed);

	std::cout << "Q = " << Q << std::endl;
	std::cout << "Q % 95 + 1 = " << (Q % 95) + 1 << std::endl;

	return 0;
}
